type binop = Add | Sub | Mult | Div | Rdiv | Xor | Or 
   | And | Equal | Neq | Less | Leq | Greater | Geq

type unop = Uminus | Not

type data_type = Char | Ord1 | Ord2 | Ord4 | Void

type rcb = int * string

type expr =
        Literal of int
      | Id of string
      | Array of string * expr * data_type
      | Binop of expr * binop * expr
      | Uniop of unop * expr
      | Assign of string * expr
      | Arrayassign of string * expr * data_type * expr
      | Call of string * expr list
      | Paren of expr
      | Noexpr

type vdecl =
        Initvardecl of data_type * string * int
      | Uninitvardecl of data_type * string
      | Initarraydecl of string * int * int
      | Uninitarraydecl of string * int


type paramdecl =
        Pdecl of data_type * string
      | Pdecla of string * int

type stmt =
        Block of stmt list
      | Expr of expr
      | Return of expr
      | If of expr * stmt * stmt
      | For of expr * expr * expr * stmt
      | While of expr * stmt
      | Rcbcall of rcb list
      | Nostmt

type rcb_def = {
        rcbdef_name : string;
        rcbdef_vdecls : vdecl list;
        rcbdef_body : stmt list;
      }

type func_def = {
        fdef_name : string;
        fdef_params : paramdecl list;
        fdef_vdecls : vdecl list;
        fdef_body : stmt list;
        fdef_rtype : data_type;
      }

type rcb_decl = string

type treg_decl = string

type func_decl = {
        fdecl_name : string;
        fdecl_params : paramdecl list;
        fdecl_rtype : data_type;
      }

type program = vdecl list * func_decl list * rcb_decl list * treg_decl list * func_def list * rcb_def list 

